#include <stdio.h>
void quickSort(int arr[], int low, int high);
int getIndex(int arr[], int low, int high);
void quickSort(int arr[], int low, int high) {
    if (low < high) {
        int index = getIndex(arr, low, high); // 找寻基准数据的正确索引
        quickSort(arr, low, index - 1); // 对左半段排序
        quickSort(arr, index + 1, high); // 对右半段排序
    }
}
int getIndex(int arr[], int low, int high) {
    int pivot = arr[low]; // 基准数据
    while (low < high) {
        // 从右边找到第一个小于基准的元素
        while (low < high && arr[high] >= pivot) { high--; }
        arr[low] = arr[high]; // 将小于基准的数据移到左侧
        // 从左边找到第一个大于基准的元素
        while (low < high && arr[low] <= pivot) {  low++; }
        arr[high] = arr[low]; // 将大于基准的数据移到右侧
    }
    arr[low] = pivot; // 将基准数据放到正确位置
    return low; // 返回基准数据的索引
}
int main() {
    int arr[] = { 3, 5, 2, 6};
    int n = sizeof(arr) / sizeof(arr[0]);
    quickSort(arr, 0, n - 1);    
    printf("排序后: ");
    for (int i = 0; i < n; i++)   
         printf("%d ", arr[i]);  
    printf("\n");
    return 0;
}